package gui;

import java.awt.EventQueue;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;
import java.awt.BorderLayout;
import javax.swing.JTabbedPane;

import music.Song;

import javax.swing.JButton;
import java.awt.FlowLayout;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import net.miginfocom.swing.MigLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

public class NewSongDialog extends JDialog {
	private JPanel southPanel;
	private JTabbedPane tabbedPane;
	private JPanel panel;
	private JPanel panel_1;
	private JButton btnOk;
	private JButton btnCancel;
	
	private Song song;
	private NewSongDialog thisNewSongDialog = this;
	private JLabel lblTitle;
	private JTextField songTitleTextField;
	private JLabel lblTime;
	private JTextField songDurationTextField;
	private JLabel lblLyrics;
	private JScrollPane scrollPane;
	private JTextArea lyricsTextArea;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					NewSongDialog dialog = new NewSongDialog();
					dialog.setDefaultCloseOperation(JDialog.DISPOSE_ON_CLOSE);
					dialog.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the dialog.
	 */
	public NewSongDialog() {
		setTitle("New song");
		setBounds(200, 200, 450, 300);
		getContentPane().add(getSouthPanel(), BorderLayout.SOUTH);
		getContentPane().add(getTabbedPane(), BorderLayout.CENTER);

	}

	public NewSongDialog(JFrame frame, boolean modal) {
		setTitle("New song");
		setBounds(200, 200, 450, 300);
		getContentPane().add(getSouthPanel(), BorderLayout.SOUTH);
		getContentPane().add(getTabbedPane(), BorderLayout.CENTER);
		this.setModal(modal);
	}

	private JPanel getSouthPanel() {
		if (southPanel == null) {
			southPanel = new JPanel();
			FlowLayout flowLayout = (FlowLayout) southPanel.getLayout();
			flowLayout.setAlignment(FlowLayout.RIGHT);
			southPanel.add(getBtnOk());
			southPanel.add(getBtnCancel());
		}
		return southPanel;
	}
	private JTabbedPane getTabbedPane() {
		if (tabbedPane == null) {
			tabbedPane = new JTabbedPane(JTabbedPane.TOP);
			tabbedPane.addTab("Info", null, getPanel(), null);
			tabbedPane.addTab("Lyrics", null, getPanel_1(), null);
		}
		return tabbedPane;
	}
	private JPanel getPanel() {
		if (panel == null) {
			panel = new JPanel();
			panel.setLayout(new MigLayout("", "[grow]", "[][][][]"));
			panel.add(getLblTitle(), "cell 0 0");
			panel.add(getSongTitleTextField(), "cell 0 1,growx");
			panel.add(getLblTime(), "cell 0 2");
			panel.add(getSongDurationTextField(), "cell 0 3,growx");
		}
		return panel;
	}
	private JPanel getPanel_1() {
		if (panel_1 == null) {
			panel_1 = new JPanel();
			panel_1.setLayout(new MigLayout("", "[grow]", "[][grow]"));
			panel_1.add(getLblLyrics(), "cell 0 0");
			panel_1.add(getScrollPane(), "cell 0 1,grow");
		}
		return panel_1;
	}
	private JButton getBtnOk() {
		if (btnOk == null) {
			btnOk = new JButton("OK");
			btnOk.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
//					song = null;
					thisNewSongDialog.setVisible(false);
					song = new Song();
					song.setTitle(songTitleTextField.getText());
					try {
						song.setTime(Integer.parseInt(songDurationTextField.getText()));
					} catch (NumberFormatException e1) {
						// TODO Auto-generated catch block
//						e1.printStackTrace();
						song.setTime(0);
					}
					song.setLyrics(lyricsTextArea.getText());
				}
			});
		}
		return btnOk;
	}
	private JButton getBtnCancel() {
		if (btnCancel == null) {
			btnCancel = new JButton("Cancel");
			btnCancel.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					song = null;
					thisNewSongDialog.setVisible(false);
				}
			});
		}
		return btnCancel;
	}
	
	public Song showDialog() {
		this.setVisible(true);
		dispose();
		return song;
	}
	private JLabel getLblTitle() {
		if (lblTitle == null) {
			lblTitle = new JLabel("Title");
		}
		return lblTitle;
	}
	private JTextField getSongTitleTextField() {
		if (songTitleTextField == null) {
			songTitleTextField = new JTextField();
			songTitleTextField.setColumns(10);
		}
		return songTitleTextField;
	}
	private JLabel getLblTime() {
		if (lblTime == null) {
			lblTime = new JLabel("Time");
		}
		return lblTime;
	}
	private JTextField getSongDurationTextField() {
		if (songDurationTextField == null) {
			songDurationTextField = new JTextField();
			songDurationTextField.setColumns(10);
		}
		return songDurationTextField;
	}
	private JLabel getLblLyrics() {
		if (lblLyrics == null) {
			lblLyrics = new JLabel("Lyrics");
		}
		return lblLyrics;
	}
	private JScrollPane getScrollPane() {
		if (scrollPane == null) {
			scrollPane = new JScrollPane();
			scrollPane.setViewportView(getLyricsTextArea());
		}
		return scrollPane;
	}
	private JTextArea getLyricsTextArea() {
		if (lyricsTextArea == null) {
			lyricsTextArea = new JTextArea();
		}
		return lyricsTextArea;
	}
}
